/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.Widget;
import javafx.ui.Orientation;

public class Box extends Widget {
    private attribute box:<<javax.swing.JPanel>>;

    public attribute orientation: Orientation;
    public attribute content: Widget*;
}


trigger on (Box.orientation = value) {
    if (orientation == HORIZONTAL:Orientation) {
        box.setLayout(new <<javax.swing.BoxLayout>>(box, <<javax.swing.BoxLayout>>.X_AXIS));
    } else {
        box.setLayout(new <<javax.swing.BoxLayout>>(box, <<javax.swing.BoxLayout>>.Y_AXIS));
    }
}

operation Box.createComponent():<<javax.swing.JComponent>> {
    box = context:<<net.java.javafx.ui.UIContext>>.createPanel();
    box.setOpaque(false);
    if (orientation <> VERTICAL:Orientation) {
        box.setLayout(new <<javax.swing.BoxLayout>>(box, <<javax.swing.BoxLayout>>.X_AXIS));
    } else {
        box.setLayout(new <<javax.swing.BoxLayout>>(box, <<javax.swing.BoxLayout>>.Y_AXIS));
    }
    for (i in content) {
        box.add(i.getComponent());
    }
    return box;
}

trigger on (insert w into Box.content) {
    box.add(w.getComponent(), indexof w);
    box.validate();
    box.repaint();
}

trigger on (delete t from Box.content) {
    box.remove(indexof t);
    box.validate();
    box.repaint();
}
