/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.SelectableButton;
import javafx.ui.SingleSelection;

public class ButtonGroup {
    private attribute buttongroup: <<javax.swing.ButtonGroup>>;

    public attribute buttons: SelectableButton*;
    public attribute selection: Number?;
    public attribute onSelectionChange: function(oldSelection:SingleSelection,
                                          newSelection:SingleSelection);
}

trigger on (new ButtonGroup) {
    buttongroup = new <<javax.swing.ButtonGroup>>();
}

trigger on (ButtonGroup.selection[old] = value) {
    if (old <> null) {
        buttons[old].selected = false;
    }
    buttons[value].selected = true;
    if (this.onSelectionChange <> null) {
        (this.onSelectionChange)(SingleSelection {
                                     anchorIndex: old
                                         },
                                 SingleSelection {
                                     anchorIndex: value
                                         });
    }
}

trigger on (insert but into ButtonGroup.buttons) {
    but.buttonGroup = this;
    var c = but.getComponent();
    buttongroup.add((<<javax.swing.AbstractButton>>)c);
    if (but.selected) {
        selection = indexof but;
    } else if (indexof but == selection) {
        but.selected = true;
    }
}

trigger on (delete but from ButtonGroup.buttons) {
    buttongroup.remove((<<javax.swing.AbstractButton>>)but.getComponent());
}
