/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import java.awt.Font as AWTFont;
import net.java.javafx.ui.UIContext;

public class Font {
    public attribute face: FontFace?;
    public attribute faceName: String?;
    public attribute size: Number;
    public attribute style: FontStyle*;
    public operation getFont(): AWTFont;
    public operation Font(faceName:String, style:String*, size:Number);
    private operation computeStyle(n:FontStyle*): Number;
}

operation Font.Font(faceName:String, style:String*, size:Number) {
    this.faceName = faceName;
    for (i in style) {
        if (i == "PLAIN") {
            insert PLAIN:FontStyle into this.style;
        } else if (i == "ITALIC") {
            insert ITALIC:FontStyle into this.style;
        } else if (i == "BOLD") {
            insert BOLD:FontStyle into this.style;
        } else {
            throw "Bad font style {i}: expected PLAIN, BOLD, or ITALIC";
        }
    }
    this.size = size;
}

operation Font.computeStyle(n:FontStyle*) {
    var bits = 0;
    for (i in n) {
        bits = context:UIContext.setBit(bits, i.id);
    }
    return bits;
}

function Font.getFont() {
    var family = bind if face <> null then face.id else if faceName <> null then faceName else "Dialog"; 
    return if face.url <> null then context:UIContext.getFont(face.url, computeStyle(style), size) else new AWTFont(family, computeStyle(style), size);
}
