/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;

/** 
 * Provides enumerated constants that determine the 
 * visibility of horizontal scrollbars.
 *
 * <code>AS_NEEDED</code>
 * Used to set the horizontal scroll bar policy so that 
 * horizontal scrollbars are displayed only when needed.
 *
 * <code>ALWAYS</code>
 * Used to set the horizontal scroll bar policy so that 
 * horizontal scrollbars are always displayed.
 *
 * <code>NEVER</code>
 * Used to set the horizontal scroll bar policy so that 
 * horizontal scrollbars are never displayed.
 */

public class HorizontalScrollBarPolicy {
    public attribute id: Number;
}

AS_NEEDED:HorizontalScrollBarPolicy = HorizontalScrollBarPolicy {
    id: <<javax.swing.JScrollPane>>.HORIZONTAL_SCROLLBAR_AS_NEEDED
};

ALWAYS:HorizontalScrollBarPolicy = HorizontalScrollBarPolicy {
    id: <<javax.swing.JScrollPane>>.HORIZONTAL_SCROLLBAR_ALWAYS
};

NEVER:HorizontalScrollBarPolicy = HorizontalScrollBarPolicy {
    id: <<javax.swing.JScrollPane>>.HORIZONTAL_SCROLLBAR_NEVER
};
