/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.Widget;

/**
 * Romain Guy's glass pane progress panel
 */

class InfiniteProgressPanel extends Widget {
    attribute root:<<javax.swing.JRootPane>>;
    attribute backgroundOpacity: Number;
    attribute pane:<<net.java.javafx.ui.HiPerfInfiniteProgressPanel>>;
    attribute progress: Boolean;
    attribute text: String;
    attribute content: Widget;
}

attribute InfiniteProgressPanel.backgroundOpacity = 160;

operation InfiniteProgressPanel.createComponent():<<javax.swing.JComponent>> {
    root = new <<javax.swing.JRootPane>>();
    root.setContentPane(content.getComponent());
    pane = new <<net.java.javafx.ui.HiPerfInfiniteProgressPanel>>(context:<<net.java.javafx.ui.UIContext>>.createSimpleLabel(), false);
    pane.setRootPane(root);
    pane.setOpacity(backgroundOpacity);
    pane.setText(text);
    return root;
}

trigger on InfiniteProgressPanel.backgroundOpacity = value {
    pane.setOpacity(backgroundOpacity);
}



trigger on (InfiniteProgressPanel.content[old] = value) {
    root.setContentPane(content.getComponent());
}

trigger on (InfiniteProgressPanel.text = value) {
    pane.setText(value);
}

trigger on (InfiniteProgressPanel.progress = value) {
    if (content <> null) {
        pane.setVisible(value);
    }
}
