/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.ListBox;
import javafx.ui.HorizontalAlignment;
import javafx.ui.VerticalAlignment;
import javafx.ui.Border;
import javafx.ui.LineBorder;
import javafx.ui.Label;


public class ListCell {
    protected attribute cacheGeneration: Number;
    protected attribute myIndex: Number;
    protected attribute listbox: ListBox;
    public attribute dragText: String?;
    public attribute value: *;
    public attribute border: Border?;
    public attribute horizontalAlignment: HorizontalAlignment?;
    public attribute verticalAlignment: VerticalAlignment?;
    public attribute text: String;
    public attribute toolTipText: String?;
    public attribute selected: Boolean;
}

trigger on (ListCell.text[old] = value) {
    if (listbox <> null) {
        if (not listbox.locked) {
            var e:<<javax.swing.event.ListDataEvent>>;
            if (cacheGeneration < listbox.updateGeneration) {
                for (i in listbox.cells) {
                    i.myIndex = indexof i;
                    i.cacheGeneration = listbox.updateGeneration;
                }
            }
            e = new <<javax.swing.event.ListDataEvent>>(listbox.list, e.CONTENTS_CHANGED, myIndex, sizeof listbox.cells - 1);
            var ls:<<javax.swing.event.ListDataListener>>* = [];
            insert listbox.listeners into ls;
            for (j in ls) {
                j.contentsChanged(e);
            }
        }
    }
}

trigger on (ListCell.toolTipText = value) {
}

trigger on (ListCell.selected[old] = value) {
    if (listbox <> null) {
        if (not listbox.locked) {
            if (cacheGeneration < listbox.updateGeneration) {
                for (i in listbox.cells) {
                    i.myIndex = indexof i;
                    i.cacheGeneration = listbox.updateGeneration;
                }
            }
            if (value and not (myIndex in listbox.selection)) {
                insert myIndex into listbox.selection;
            } 
        }
    }
}

