/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.Widget;
import javafx.ui.Menu;

public class MenuBar extends Widget {
    private attribute jmenubar:<<javax.swing.JMenuBar>>;
    public attribute menus: Menu*;
}

attribute MenuBar.opaque = true;


trigger on (new MenuBar) {
    jmenubar = new <<javax.swing.JMenuBar>>();
    jmenubar.setOpaque(true);
    component = jmenubar;
}

trigger on (insert menu into MenuBar.menus) {
    jmenubar.add(menu.getComponent(), indexof menu);
    jmenubar.revalidate();
    jmenubar.repaint();
}

trigger on (delete menu from MenuBar.menus) {
    jmenubar.remove(indexof menu);
    jmenubar.revalidate();
    jmenubar.repaint();
}

trigger on (MenuBar.menus[oldMenu] = newMenu) {
    jmenubar.remove(indexof oldMenu);
    jmenubar.add(newMenu.getComponent(), indexof newMenu);
    jmenubar.revalidate();
    jmenubar.repaint();
}
