/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.Widget;

/** 
 * Container which provides absolute layout. You layout its content by 
 * specifing their (x, y, width, height) values.
 */

public class Panel extends Widget {
    private attribute jpanel:<<javax.swing.JPanel>>;
    /** A list of the components contained in this panel */
    public attribute content: Widget*;
}

operation Panel.createComponent() {
    jpanel = new <<javax.swing.JPanel>>();
    jpanel.setOpaque(false);
    jpanel.setLayout(null);
    for (i in content) {
        jpanel.add(i.getComponent(), indexof i);
        i.getComponent().setBounds(i.x, i.y, i.width, i.height);
    }
    return jpanel;
}

trigger on insert c into Panel.content {
    if (jpanel <> null) {
        jpanel.add(c.getComponent(), indexof c);
        c.getComponent().setBounds(c.x, c.y, c.width, c.height);
    }
}

trigger on delete w from Panel.content {
    if (jpanel <> null) {
        jpanel.remove(indexof w);
    }
}

trigger on Panel.content[oldWidget] = widget {
    if (jpanel <> null) {
        jpanel.remove(indexof oldWidget);
        jpanel.add(widget.getComponent(), indexof widget);
        widget.getComponent().setBounds(widget.x, widget.y, 
                                        widget.width, widget.height);
    }
}
