/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.Widget;
import javafx.ui.Orientation;

public class ProgressBar extends Widget {
    private attribute jprogressbar: <<javax.swing.JProgressBar>>;
    public attribute min: Number;
    public attribute max: Number;
    public attribute value: Number;
    public attribute stringPainted: Boolean;
    public attribute borderPainted: Boolean;
    public attribute string: String;
    public attribute orientation: Orientation;
    public attribute indeterminate: Boolean;
}

trigger on (new ProgressBar) {
    borderPainted = false;
    stringPainted = false;
    min = 0;
    value = 0;
    max = 100;
    orientation = HORIZONTAL:Orientation;
    indeterminate = false;
}

operation ProgressBar.createComponent() {
    jprogressbar = new <<javax.swing.JProgressBar>>();
    jprogressbar.setIndeterminate(indeterminate);
    jprogressbar.setMinimum(min);
    jprogressbar.setMaximum(max);
    jprogressbar.setValue(value);
    jprogressbar.setString(string);
    jprogressbar.setStringPainted(stringPainted);
    jprogressbar.setBorderPainted(borderPainted);
    jprogressbar.setOrientation(if orientation == VERTICAL:Orientation 
                                then jprogressbar.VERTICAL
                                else jprogressbar.HORIZONTAL);
    return jprogressbar;
}

trigger on (ProgressBar.stringPainted = value) {
    jprogressbar.setStringPainted(stringPainted);
}

trigger on (ProgressBar.borderPainted = value) {
    jprogressbar.setBorderPainted(value);
}

trigger on (ProgressBar.indeterminate = value) {
    jprogressbar.setIndeterminate(value);
}

trigger on (ProgressBar.max = value) {
    jprogressbar.setMaximum(value);
}

trigger on (ProgressBar.min = value) {
    jprogressbar.setMinimum(value);
}

trigger on (ProgressBar.value = newValue) {
    jprogressbar.setValue(newValue);
}

trigger on ProgressBar.string = value {
    jprogressbar.setString(value);
}

trigger on (ProgressBar.orientation = value) {
    jprogressbar.setOrientation(if orientation == VERTICAL:Orientation 
                                then jprogressbar.VERTICAL
                                else jprogressbar.HORIZONTAL);
}
