/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.Widget;
import javafx.ui.MenuBar;

public class RootPane extends Widget {
    private attribute jrootpane:<<javax.swing.JRootPane>>;
    public attribute menubar: MenuBar?;
    public attribute content: Widget?;
}

operation RootPane.createComponent() {
    jrootpane = new <<javax.swing.JRootPane>>();
    if (menubar <> null) {
        jrootpane.setJMenuBar(menubar.jmenubar);
    }
    if (content <> null) {
        jrootpane.setContentPane(content.getComponent());
    }
    return jrootpane;
}

trigger on (RootPane.menubar = value) {
    jrootpane.setJMenuBar(menubar.jmenubar);
}

trigger on (RootPane.content = w) {
    if (w <> null) {
       jrootpane.setContentPane(w.getComponent());
    }
}
