/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;
import javafx.ui.Widget;
import javafx.ui.HorizontalAlignment;
import javafx.ui.KeyStroke;

public class SimpleLabel extends Widget {
    private attribute jlabel:<<javax.swing.JLabel>>;
    public attribute text:String;
    public attribute icon:Icon?;
    public attribute horizontalAlignment:HorizontalAlignment;
    public attribute mnemonic: KeyStroke?;
    public attribute labelFor: Widget?;
}


operation SimpleLabel.createComponent() {
    if (horizontalAlignment == null) {
        horizontalAlignment = LEADING:HorizontalAlignment;
    } 
    jlabel = context:<<net.java.javafx.ui.UIContext>>.createSimpleLabel();
    jlabel.setOpaque(false);
    jlabel.setText(text);
    jlabel.setIcon(icon.getIcon());
    jlabel.setHorizontalAlignment(horizontalAlignment.id);
    if (labelFor <> null) {
        jlabel.setLabelFor(labelFor.getComponent());
    }
    if (mnemonic <> null) {
        jlabel.setDisplayedMnemonic(mnemonic.id);
    }
    return jlabel;
}

trigger on (SimpleLabel.text = s) {
    jlabel.setText(s);
}

trigger on (SimpleLabel.labelFor = w) {
    jlabel.setLabelFor(w.getComponent());
}

trigger on (SimpleLabel.mnemonic = k) {
    jlabel.setDisplayedMnemonic(k.id);
}

trigger on (SimpleLabel.icon = i) {
    jlabel.setIcon(i.getIcon());
}

trigger on (SimpleLabel.horizontalAlignment = a) {
    jlabel.setHorizontalAlignment(a.id);
}

