/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui;

/**
 * Defines one element of the ramp of colors to use on a gradient. 
 */

public class Stop {
    /** 
     * The offset attribute is a number ranging from 0 to 1 which indicates where 
     * this gradient stop is placed. For linear gradients, the offset attribute 
     * represents a location along the gradient vector. For radial gradients, it 
     * represents a percentage distance from (focusX,focusY) to the edge of the 
     * outermost/largest circle.
     */
    public attribute offset: Number;
    /** Indicates what color to use at this gradient stop. */
    public attribute color: Color;
}
