/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.canvas.Shape;
import net.java.javafx.jazz.component.ZEllipse;

/**
 * The <code>Circle</code> class describes a circle that is defined
 * by a center point (cx, cy), and a radius (radius).
 */
public class Circle extends Shape {
    private attribute zellipse: ZEllipse;
    /** The x coordinate of the center point of this circle. */
    public attribute cx: Number;
    /** The y coordinate of the center point of this circle. */
    public attribute cy: Number;
    /** The radius of this circle. */
    public attribute radius: Number;
}


trigger on Circle.cx = value {
    var x = cx - radius;
    var y = cy - radius;
    var width = 2*radius;
    var height = 2*radius;
    zellipse.setFrame(x, y, width, height);
}

trigger on Circle.cy = value {
    var x = cx - radius;
    var y = cy - radius;
    var width = 2*radius;
    var height = 2*radius;
    zellipse.setFrame(x, y, width, height);
}

trigger on Circle.radius = value {
    var x = cx - radius;
    var y = cy - radius;
    var width = 2*radius;
    var height = 2*radius;
    zellipse.setFrame(x, y, width, height);
}

operation Circle.createShape() {
    var x = cx - radius;
    var y = cy - radius;
    var width = 2*radius;
    var height = 2*radius;
    zellipse = new ZEllipse(x, y, width, height);
    return zellipse;
}
