/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.canvas.Shape;
import net.java.javafx.jazz.component.ZEllipse;
/**
 * The <code>Ellipse</code> class describes an ellipse that is defined
 * by a center point (cx, cy), a horizontal radius (radiusX), and a vertical
 * radius (radiusY).
 */

public class Ellipse extends Shape {
    private attribute zellipse: ZEllipse;
    /** the x coordinate of the center point of this ellipse.*/
    public attribute cx: Number;
    /** the y coordinate of the center point of this ellipse.*/
    public attribute cy: Number;
    /** the horizontal radius of this ellipse.*/
    public attribute radiusX: Number;
    /** the vertical radius of this ellipse.*/
    public attribute radiusY: Number;
}


trigger on Ellipse.cx = value {
    var x = cx - radiusX;
    var y = cy - radiusY;
    var width = 2*radiusX;
    var height = 2*radiusY;
    zellipse.setFrame(x, y, width, height);
}

trigger on Ellipse.cy = value {
    var x = cx - radiusX;
    var y = cy - radiusY;
    var width = 2*radiusX;
    var height = 2*radiusY;
    zellipse.setFrame(x, y, width, height);
}

trigger on Ellipse.radiusX = value {
    var x = cx - radiusX;
    var y = cy - radiusY;
    var width = 2*radiusX;
    var height = 2*radiusY;
    zellipse.setFrame(x, y, width, height);
}

trigger on Ellipse.radiusY = value {
    var x = cx - radiusX;
    var y = cy - radiusY;
    var width = 2*radiusX;
    var height = 2*radiusY;
    zellipse.setFrame(x, y, width, height);
}

operation Ellipse.createShape() {
    var x = cx - radiusX;
    var y = cy - radiusY;
    var width = 2*radiusX;
    var height = 2*radiusY;
    zellipse = new ZEllipse(x, y, width, height);
    return zellipse;
}
