/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import java.awt.geom.AffineTransform;
import java.lang.Math;

/**
 * Transformation operation which rotates an object.  
 */

public class Rotate extends Transform {
    /** The amount of rotation in degrees */
    public attribute angle: Number;
    /** The x coordinate of the center point about which this rotation will be performed. Defaults to zero. */
    public attribute cx: Number;
    /** The y coordinate of the center point about which this rotation will be performed. Defaults to zero. */
    public attribute cy: Number;
}

trigger on Rotate.cx = value {
    transform = 
    AffineTransform.getRotateInstance(Math.toRadians(angle), cx, cy);
}

trigger on Rotate.cy = value {
    transform = 
    AffineTransform.getRotateInstance(Math.toRadians(angle), cx, cy);
}

trigger on Rotate.angle = value {
    transform = 
    AffineTransform.getRotateInstance(Math.toRadians(angle), cx, cy);
}

rotate:Rotate = operation(z:Number, cx:Number, cy:Number) {
    return Rotate {cx: cx, cy: cy, angle: z};
};
