/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import java.awt.geom.AffineTransform;

/**
 * Transformation operation which scales an object.  
 */
public class Scale extends Transform {
    /** The factor to scale along the x axis */
    public attribute x: Number;
    /** The factor to scale along the y axis */
    public attribute y: Number;
}

trigger on Scale.x = value {
    if (x <> 0 and y <> 0) {
       transform = AffineTransform.getScaleInstance(x, y);
    }
}

trigger on Scale.y = value {
    if (x <> 0 and y <> 0) {
        transform = AffineTransform.getScaleInstance(x, y);
    }
}

scale:Scale = function(x:Number, y:Number) {
    return Scale {x: bind x, y: bind y};
};

scaleX:Scale = operation(x:Number) {
    return Scale {x: x, y: 1};
};

scaleY:Scale = operation(y:Number) {
    return Scale {x: 1, y: y};
};

scaleXY:Scale = operation(s:Number) {
    return Scale {x: s, y: s};
};


