/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.canvas.Layout;
import javafx.ui.canvas.Shape;
import net.java.javafx.jazz.ZPathLayoutManager;
import net.java.javafx.jazz.event.*;
import net.java.javafx.jazz.ZLayoutGroup;

public class ShapeLayout extends Layout {
    private attribute layoutmgr: ZPathLayoutManager;
    public attribute shape: Shape;
    public attribute exactSpacing: Boolean;
}

attribute ShapeLayout.exactSpacing = true;

operation ShapeLayout.createNode() {
    layoutgroup = new ZLayoutGroup();
    var self = this;
    layoutmgr = new ZPathLayoutManager(shape.getTransformedShape());
    layoutmgr.setExact(exactSpacing);
    layoutmgr.setClosed(true);
    layoutgroup.setLayoutManager(layoutmgr);
    for (i in content) {
        layoutgroup.addChild(i.getNode());
    }
    var count = 0;
    var inLayout = false;
    layoutgroup.addNodeListener(new ZNodeListener() {
        operation boundsChanged(e:ZNodeEvent) {
        if (inLayout) {
            return;
        }     
        if (e.getNode() <> self.layoutgroup) {
             inLayout = true;
             var c = ++count;
             do later {
                if (c == count) {
                    self.layoutgroup.invalidate();
                    self.layoutgroup.doLayout();
                    inLayout = false;
                }
             }
        }}
    });

    return layoutgroup;
}


trigger on ShapeLayout.shape = newValue {
    if (layoutmgr <> null) {
        layoutmgr.setShape(shape.getTransformedShape());
        layoutgroup.invalidate();
        layoutgroup.doLayout();
    }
}
