/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.canvas;
import javafx.ui.*;

public class VBox extends CompositeNode {
    private attribute holders: Group*;
    public attribute content: Node*;
}

attribute VBox.holders = 
  bind foreach (t in content)
     Group {
          var: self
          var prev = bind if indexof t > 0 and self.hasParent() 
                         then holders[indexof t-1] else null
          var y = bind if prev == null 
                    then 0 else prev.currentY + prev.currentHeight
          transform: bind translate(0, y)
          content: t
     }

;

function VBox.composeNode() = 
    Group {
        content: bind holders
    }
;
