/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.filter;
import javafx.ui.filter.LightFilter;
import com.jhlabs.image.ChromeFilter as JHChromeFilter;

// Chrome

public class Chrome extends LightFilter {
    protected attribute chromeFilter: JHChromeFilter;
    public attribute amount: Number;
    public attribute exposure: Number;
}

attribute Chrome.amount = 0.5;
attribute Chrome.exposure = 1.0;

operation Chrome.createLightFilter() {
    chromeFilter = new JHChromeFilter();
    chromeFilter.setAmount(amount);
    chromeFilter.setExposure(exposure);
    return chromeFilter;
}

trigger on Chrome.amount = value {
    chromeFilter.setAmount(value);
}

trigger on Chrome.exposure = value {
    chromeFilter.setExposure(value);
}
