/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.filter;
import java.awt.image.BufferedImage;
import java.awt.image.BufferedImageOp;
import java.awt.Image;

class ScaleFilter extends Filter {
    attribute x: Number;
    attribute y: Number;
}

operation ScaleFilter.createFilter() {
    var self = this;
    return new BufferedImageOp() {
            operation filter(src:BufferedImage, dst:BufferedImage) {
                var w = src.getWidth()*self.x;
                var h = src.getHeight()*self.y;
		var scaleImage = src.getScaledInstance(w,  h, Image.SCALE_AREA_AVERAGING );
                if (dst == null) {
                    dst = new BufferedImage(src.colorModel,
                                            src.colorModel.createCompatibleWritableRaster(w, h),
                                            src.colorModel.isAlphaPremultiplied(), null);     
                }
                var g = dst.createGraphics();
		g.drawImage( src, 0, 0, w, h, null );
                g.dispose();
                return dst;
            }
       };
}

