/*
 *  $Id$
 * 
 *  Copyright 2007 Sun Microsystems, Inc. All rights reserved.
 *  SUN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package javafx.ui.filter;
import javafx.ui.Color;
import javafx.ui.filter.Filter;
import com.jhlabs.image.ShadowFilter as JHShadowFilter;
import java.lang.Math;


public class ShadowFilter extends Filter {
    protected attribute shadowFilter: JHShadowFilter;
    /** Sets the radius of the gaussian blur kernel **/
    public attribute radius: Number;
    public attribute angle: Number;
    public attribute distance: Number;
    public attribute x: Number;
    public attribute y: Number;
    public attribute opacity: Number;
    public attribute shadowColor: Color;
    public attribute addMargins: Boolean;
    public attribute shadowOnly: Boolean;
}

attribute ShadowFilter.angle = Math.toDegrees(Math.PI*6/4);
attribute ShadowFilter.radius = 5;
attribute ShadowFilter.distance = 5;
attribute ShadowFilter.opacity = 0.5;
attribute ShadowFilter.addMargins = true;
attribute ShadowFilter.shadowOnly = false;
attribute ShadowFilter.shadowColor = black;

operation ShadowFilter.createFilter() {
    if (shadowFilter == null) {
        shadowFilter = new JHShadowFilter(radius, x, y, opacity);
        shadowFilter.setRadius(radius);
        //shadowFilter.setAngle(Math.toRadians(angle));
        shadowFilter.setDistance(distance);
        shadowFilter.setOpacity(opacity);
        shadowFilter.setShadowColor(shadowColor.getColor().getRGB());
        shadowFilter.setAddMargins(addMargins);
        shadowFilter.setShadowOnly(shadowOnly);
    }
    return shadowFilter;
}
